	/*

	Copyright (C) 1998 Stefan Westerfeld
                       stefan@space.twc.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    */

#include "synthmodule.h"

QString SynthModule::getArgument(int nr, ArgType direction)
{
	QString arglist = getParams();
	static QString result;
	int index=0, pos=arglist.find(';');

	arglist.detach();
	if(direction == arg_out)
		arglist = arglist.mid(pos+1,arglist.length()-pos-1);
	else
		arglist = arglist.mid(0,pos);

	fprintf(stderr,"dbg: arglist = %s\n",arglist.data());
	while(nr>0)
	{
		nr--;
		index = arglist.find(',',index)+1;
		if(index == 0) return(NULL);
		if(arglist.mid(index-1,1) == QString(";")) return(NULL);
	}
	fprintf(stderr,"dbg: index = %d\n",index);
	int end = arglist.find(',',index);
	if(end == -1) { end = arglist.length(); }

	result = arglist.mid(index,end-index);
	return(result);
};

void SynthModule::ProcessData(QString data)
{
	fprintf(stderr,"data could not be processed by %s\n",getName().data());
}

void SynthModule::DeInitialize()
{
	// do nothing
}

void *SynthModule::get_MS()
{
	static ModuleServer<SynthModule> *MS = 0;
	printf("Obtaining a ModuleServer reference for SynthModules\n");
	if(!MS)
	{
		printf("Creating a ModuleServer for SynthModules\n");
		MS = new ModuleServer<SynthModule>;
	}
	printf("ModuleServer is at %lx\n",MS);

	return(MS);
}
